######################
# ONI TEAM ARENA 1.0 #
######################
# arena_menu.bsl for Rooftops
#########################
# The menu provides advanced functionality like :
# -shapeshifting bots (F2 then CREEP BACK)
# -restarting the current area (F2 then KICK)
# -going to next area (F3)
# F2 and F3 are only active when Oni is recording a movie (F5)
############
var int arena_menu= 0;
var string arena_menu_name; var string arena_menu_nick;
############ 
func void ArenaAdvanced(void) {
	arena_menu= 0; arena_spawn_id= 0; ArenaMenuName();
	sc_bind_f2= KONOKOwatch_start; bind fkey2 to cutscene1
	sc_bind_f3= KONOKOwatch_idle; bind fkey3 to cutscene2
	sleep 30; fork ArenaF2(); fork ArenaF3(); fork ArenaCycler();
}
######## AREA CYCLER (CORE)
func void ArenaF3(void) {
	chr_wait_animation(0, KONOKOwatch_idle);
	if(!arena_menu) fork ArenaReset(1);
	else            fork ArenaReset(0);
	sleep 60; fork ArenaF3();
}
######## BOT SHAPESHIFTER (CORE)
func void ArenaF2(void) {
	chr_wait_animation(0, KONOKOwatch_start);
	ai2_allpassive(1); p3_removedangerous();
	arena_scoring= 0; chr_draw_all_characters= 1; arena_menu= 1;
	arena_spawn_id= 0; ArenaMenuName();
		dmsg(" "); PrintPlayer(arena_spawn_id); dmsg(arena_menu_nick);
		dmsg("CREEP BACK = next player"); dmsg("KICK = reset");
	sleep 61; chr_wait_animation(0, KONOKOwatch_start);
	arena_menu= 2; chr_draw_all_characters= 0;
		dmsg(" "); dmsg("DM GUN MODE SELECTOR"); ArenaGunsInfo();
		dmsg("CREEP BACK = next mode"); dmsg("F2 = exit; F3 = restart");
	sleep 61; chr_wait_animation(0, KONOKOwatch_start);
	arena_menu= 0; ai2_allpassive(0); arena_scoring= 1; fork ArenaAreaInfo();
	sleep 61; fork ArenaF2();
}
######## BOT CYCLER (CORE)
func void ArenaCycler(void) {
	chr_wait_animtype(arena_menu_name, crouch_run_backwards);
	if(arena_menu eq 1) {
		ai2_takecontrol(1); chr_neutral(arena_menu_name, 0);
		arena_spawn_id= arena_spawn_id + 1;
		if(arena_spawn_id >= arena_players) arena_spawn_id= 0; 
		ArenaMenuName();
		dmsg(" "); PrintPlayer(arena_spawn_id); dmsg(arena_menu_nick);
		dmsg("CREEP BACK = next player");
		if(arena_spawn_id) dmsg("SHAPESHIFT player");
		else dmsg("KICK = reset");
		chr_focus(arena_spawn_id);
		chr_neutral(arena_menu_name, 1); ai2_takecontrol(0);
#		chr_dontaim(arena_menu_name, 0);
		chr_debug_target= arena_spawn_id;
	}
	if(arena_menu eq 2) {
		dmsg(" "); dmsg("[r.DM GUN MODE SELECTOR]");
		ArenaGunsNextMode(); ArenaGunsInfo();
		dmsg("CREEP BACK = next mode");
		dmsg("F2 = exit; F3 = restart");
	}
	sleep 30; fork ArenaCycler();
}
######## PRINTS PLAYER INDEX (FOR BOT SHAPESHIFTING)
func void PrintPlayer(int player_id) {
	if(player_id eq 0) dmsg("PLAYER 0:");
	if(player_id eq 1) dmsg("PLAYER 1:");
	if(player_id eq 2) dmsg("PLAYER 2:");
	if(player_id eq 3) dmsg("PLAYER 3:");
	if(player_id eq 4) dmsg("PLAYER 4:");
	if(player_id eq 5) dmsg("PLAYER 5:");
	if(player_id eq 6) dmsg("PLAYER 6:");
	if(player_id eq 7) dmsg("PLAYER 7:");
	if(player_id eq 8) dmsg("PLAYER 8:");
	if(player_id eq 9) dmsg("PLAYER 9:");
	if(player_id eq 10) dmsg("PLAYER 10:");
	if(player_id eq 11) dmsg("PLAYER 11:");
	if(player_id eq 12) dmsg("PLAYER 12:");
	if(player_id eq 13) dmsg("PLAYER 13:");
	if(player_id eq 14) dmsg("PLAYER 14:");
	if(player_id eq 15) dmsg("PLAYER 15:");
	if(player_id eq 16) dmsg("PLAYER 16:");
	if(player_id eq 17) dmsg("PLAYER 17:");
	if(player_id eq 18) dmsg("PLAYER 18:");
	if(player_id eq 19) dmsg("PLAYER 19:");
	if(player_id eq 20) dmsg("PLAYER 20:");
	if(player_id eq 21) dmsg("PLAYER 21:");
}
