######################
# ONI TEAM ARENA 1.1 #
######################
# arena_main.bsl for Rooftops
######################
var int arena_area= 0; var int arena_players; var int arena_spawn_id;
var int arena_scoring;
################ ARENA STARTUP
func void main(void) {
	fork super_kick
    fork super_punch
    fork left_kick
    fork right_kick
	ArenaSetupLevel();
######## MISC SETUP
	chr_auto_aim_dist= 0; ui_suppress_prompt= 1;
#	ai2_showlinetochar= 1;
######## ADVANCED SETTINGS
	arena_menu_active= 0; chr_draw_all_characters= 1;
######## LAUNCH RANDOMIZER
	fork RandInit(); sleep 1;
######## LAUNCH GAME PROCESSES
	fork ArenaWelcome(); 
	fork ArenaMusic();
	ArenaResetFlags(); 
 	ArenaResetWeapons(); 
	ArenaResetScore();
	fork ArenaSetupTeams(); 
}
######## RESPAWN LOGIC (CORE)
func void RespawnPlayer(string ai_team, string ai_name, string ai_nick) {
	if(chr_is_player(ai_name)) RandMusic();
	chr_invincible(ai_name, 1); chr_full_health(ai_name);
	fork SendToRandFlag(ai_name, ai_team);
	ai2_idle(ai_name); sleep 1; ai2_setjobstate(ai_name);
	chr_inv_reset(ai_name);
	fork GiveRandWeapon(ai_name);
	fork GiveRandPowerups(ai_name);
	ai2_setalert(ai_name, high); ai2_setmovementmode(ai_name, run);
	fork ArenaAwareness();
	sleep 30; chr_invincible(ai_name, 0);

	chr_wait_health(ai_name, 1); chr_pain(ai_name, death);
	if(arena_scoring) fork Death(ai_team, ai_name, ai_nick);
	chr_inv_reset(ai_name); chr_givepowerup(ai_name, invis, -1);
	chr_changeteam(ai_name, Switzerland);
	sleep 60; chr_changeteam(ai_name, ai_team);
	fork RespawnPlayer(ai_team, ai_name, ai_nick);
}
func void AddPlayer(string ai_team, string ai_name, string ai_nick) {
	dmsg(ai_nick); dmsg("entered the arena");
	ai2_spawn(ai_name); chr_changeteam(ai_name, ai_team);
	arena_players= arena_players + 1;
	ai2_noncombatant(ai_name, 0); chr_unkillable(ai_name, 1);
	fork RespawnPlayer(ai_team, ai_name, ai_nick);
}
#################################### ARENA RESET
######## CYCLING AREAS (CUSTOM)
func void ArenaNextArea(void) {
	arena_area= arena_area + 1; if(arena_area > 3) arena_area= 0;
	if(arena_area eq 0) dmsg "[b.ARENA 0] : [o.BIG BROTHERS]"
	if(arena_area eq 1) dmsg "[b.ARENA 1] : [y.MUKADE'S FATE]"
	if(arena_area eq 2) dmsg "[b.ARENA 2] : [g.SIAMESE TWINS]"
	if(arena_area eq 3) dmsg "[b.ARENA 3] : [r.SKIRMISH INC.]"
}
######## KILLS EVERYBODY WITH AN ID GREATER THAN arena_spawn_id
func void ArenaKillPlayerSeq(void) {
	chr_health(arena_spawn_id, 1);
	sleep 1; arena_spawn_id= arena_spawn_id + 1;
	if(arena_spawn_id < arena_players) fork ArenaKillPlayerSeq();
	else ArenaResetScore();
}

func ArenaKillAllPlayers {
#For Konoko, we could also use her script ID, 0
chr_set_health char_0 1
sleep 1; chr_set_health IntroNinja 1
sleep 1; chr_set_health A_N1 1
sleep 1; chr_set_health A_Sr9 1
sleep 1; chr_set_health NinjaZip 1
sleep 1; chr_set_health A_C5 1
sleep 1; chr_set_health D_C19 1
sleep 1; chr_set_health D_C60 1
sleep 1; chr_set_health D_T28 1
sleep 1; chr_set_health E_Sb31 1
sleep 1; chr_set_health E_C62 1
sleep 1; chr_set_health E_Sr64 1
sleep 1; chr_set_health D_R21 1
sleep 1; chr_set_health A_N7 1
sleep 1; chr_set_health B_R11 1
sleep 1; chr_set_health B_T13 1
sleep 1; chr_set_health C_T16 1
sleep 1; chr_set_health E_Sr30 1
sleep 1; chr_set_health A_T4 1
sleep 1; chr_set_health E_Sr33 1

}

######## ARENA RESET
func void ArenaReset(int next_area) {
	dmsg " "
	if(next_area) ArenaNextArea()
	else dmsg " "
 	ArenaResetLevel(); ArenaResetWeapons(); ArenaResetFlags();
	ai2_allpassive(0); arena_scoring= 0;
	arena_spawn_id= 0; 
	ArenaKillAllPlayers
	ArenaResetScore();
	dmsg "FIGHT!"
}

func super_kick(void) {
chr_wait_animation 0 KONCOMcomb_p_p_k
chr_animate 0 KONCOMsuper_kick
sleep 50
fork super_kick
}

func super_punch(void) {
chr_wait_animation 0 KONCOMcomb_p_p_p
chr_animate 0 KONCOMsuper_punch
sleep 50
fork super_punch
}

func left_kick(void) {
chr_wait_animation 0 KONCOMkick_lt
chr_animate 0 KONCOMrt_fw_kick
sleep 50
fork left_kick
}

func right_kick(void) {
chr_wait_animation 0 KONCOMkick_rt
chr_animate 0 KONCOMlt_fw_kick
sleep 50
fork right_kick
}
