########################
#  ONI TEAM ARENA 1.2  #
#  Airport_III         #
########################
var int arena_area= 0;
var int arena_players; var int arena_spawn_id;
var int arena_scoring;
var int arena_tag; var int arena_relocate= 1;
################ ARENA STARTUP
func void main(void) {
	ArenaSetupLevel();
######## MISC SETUP
	chr_auto_aim_dist= 0; ui_suppress_prompt= 1;
#	ai2_showlinetochar= 1;
######## ADVANCED SETTINGS
	arena_menu= 0; chr_draw_all_characters= 0;
######## LAUNCH RANDOMIZER
	fork RandInit(); sleep 1;
######## LAUNCH GAME PROCESSES
	ArenaResetFlags(); 
	ArenaResetWeapons(); 
	ArenaResetScore();
	fork ArenaAreaInfo(); 
	fork ArenaMusic();
 	fork ArenaAdvanced(); 
	fork ArenaSetupTeams();
}
func void ArenaTeamsComplete(void) {
	if(arena_tag) arena_relocate= 0;
}
######## RESPAWN LOGIC (CORE)
func void RespawnPlayer(int ai_id, string ai_team, string ai_name, string ai_nick) {
	if(chr_is_player(ai_name)) RandMusic();
	chr_invincible(ai_name, 1); chr_full_health(ai_name);
	fork SendToRandFlag(ai_id, ai_name, ai_team);
	chr_inv_reset(ai_name);
	fork GiveRandWeapon(ai_name);
	fork GiveRandPowerups(ai_name);
	ai2_idle(ai_name); ai2_setjobstate(ai_name);
	ai2_setalert(ai_name, high); ai2_setmovementmode(ai_name, run);
	sleep 30; chr_invincible(ai_name, 0);
	fork ArenaAwareness();

	chr_wait_health(ai_name, 1); if(new_oni eq none) new_oni= ai_name;
	if(arena_scoring) fork Death(ai_team, ai_name, ai_nick);
	if(arena_scoring and ai_name eq arena_bomber_name) {
# KILL THE BOMBER AND RESPAWN HIM WITH THE SAME ID
		chr_set_health(ai_name, 0);
		sleep 200; chr_draw_all_characters= 0;
		ai2_spawn(ai_name, force);
	}
	else {
# FADE PLAYER OTHER PLAYERS
		chr_inv_reset(ai_name); chr_givepowerup(ai_name, invis, -1);
		chr_changeteam(ai_name, Switzerland);
		sleep 60;
	}
	chr_changeteam(ai_name, ai_team);
	fork RespawnPlayer(ai_id, ai_team, ai_name, ai_nick);
}

func void AddPlayer(string ai_team, string ai_name, string ai_nick) {
	dmsg(ai_nick); dmsg("entered the arena");
	ai2_spawn(ai_name); chr_changeteam(ai_name, ai_team);
	ai2_neutralbehavior(ai_name, none)
#	ai2_passive(ai_name, 0); chr_neutral(ai_name, 0);
#	chr_freeze(ai_name, 0); ai2_active(ai_name);
#	chr_lock_active(ai_name);
	ai2_noncombatant(ai_name, 0); chr_unkillable(ai_name, 1);
	if(!arena_tag) fork RespawnPlayer(arena_players, ai_team, ai_name, ai_nick);
	else fork RespawnPlayerTag(arena_players, ai_team, ai_name, ai_nick);
	arena_players= arena_players + 1;
}
#################################### ARENA RESET PC Version
######## KILLS EVERYBODY WITH AN ID GREATER THAN arena_spawn_id
func void ArenaKillPlayerSeq(int player) {
	chr_health(player, 1); player= player + 1; sleep 1;
	if(player < arena_players) fork ArenaKillPlayerSeq(player);
	else chr_pin_character= 0;
#	chr_draw_all_characters= 1;
	
#	chr_health(1, 1); sleep 1;
#	chr_health(2, 1); sleep 1;
#	chr_health(3, 1); sleep 1;
#	chr_health(4, 1); sleep 1;
#	chr_health(5, 1); sleep 1;
#	chr_health(6, 1); sleep 1;
#	chr_health(7, 1); sleep 1;
#	chr_health(8, 1); sleep 1;
#	chr_health(9, 1); sleep 1;
#	chr_health(10, 1); sleep 1;
#	chr_health(11, 1); sleep 1;
#	chr_health(12, 1); sleep 1;
#	chr_health(13, 1); sleep 1;
#	chr_health(14, 1); sleep 1;
#	chr_health(15, 1);
#	chr_pin_character= 0;
#	chr_draw_all_characters= 0; 	
#	chr_health(arena_spawn_id, 1);
#	sleep 1; arena_spawn_id= arena_spawn_id + 1;
#	if(arena_spawn_id < arena_players) fork ArenaKillPlayerSeq();
}



######## ARENA RESET
func void ArenaReset(int next_area) {
	arena_relocate= 1;
	
	if(next_area) {
		dmsg " "
		arena_area= arena_area + 1;
		if(arena_area >= arena_areas) arena_area= 0;
		fork ArenaAreaInfo();
	}
 	fade_out(0, 0, 0, 50); 
	arena_scoring= 0; sleep 50;
	ArenaResetLevel(); 
	ArenaResetWeapons(); 
	ArenaResetFlags(); sleep 1;
#	arena_spawn_id= 0;
#	chr_pin_character= 1;
	ArenaKillAllPlayers(); 
	ai2_allpassive(0);
	sleep 100; fade_in(100);
	ArenaResetScore(); 
#	if(next_area) arena_scoring= 1;
#	if(arena_tag) arena_relocate= 0;
}

######################
# ONI TEAM ARENA 1.2 #
# LEVEL              #
######################
var int arena_areas= 3;
var int arena_air_quality= 0;
var int arena_air_quality_custom= 0;

func ArenaSetupLevel {
	gl_fog_red= 0; gl_fog_green= 0; gl_fog_blue= 0;
	gl_fog_start= .995; gs_farclipplane_set(4000);
	arena_area= 0; door_ignore_locks= 1
}


######## CYCLING AREAS (CUSTOM)
func ArenaAreaInfo {
	dmsg " "
	if(arena_area eq 0) dmsg "[b.ARENA 0] : [b.BLUELINE]"
	if(arena_area eq 1) dmsg "[b.ARENA 1] : [o.AIRPLANE]"
	if(arena_area eq 2) dmsg "[b.ARENA 2] : [g.LOBBYMEN]"
	ArenaGunsInfo(); ArenaScoreInfo(); dmsg "FIGHT!"
}

# WHEN AN ARENA RESTARTS
func ArenaResetLevel {

	if(!arena_air_quality_custom) {
		arena_air_quality= 0;
		if(arena_area eq 0) arena_air_quality= 2;
		if(arena_area eq 1) arena_air_quality= 1;
		if(arena_area eq 2) arena_air_quality= 3;
#		if(arena_area eq 3) arena_air_quality= 2;
#		if(arena_area eq 5) arena_air_quality= 3;
#		if(arena_area eq 1) gs_show_environment= 0
#		else gs_show_environment= 1
	}
	if(arena_air_quality eq 0) {
		gl_fog_red= 0; gl_fog_green= 0; gl_fog_blue= 0;
		gl_fog_start= .995;
	}
	if(arena_air_quality eq 1) {
		gl_fog_red= .2; gl_fog_green= 0; gl_fog_blue= .2;
		gl_fog_start= .95;
	}
	if(arena_air_quality eq 2) {
		gl_fog_red= 0; gl_fog_green= .3; gl_fog_blue= 0;
		gl_fog_start= .8;
	}
	if(arena_air_quality eq 3) {
		gl_fog_red= .3; gl_fog_green= .1; gl_fog_blue= 0;
		gl_fog_start= .7;
	}
}
# AIR QUALITY MENU
func ArenaAirQualityNext {
	arena_air_quality_custom= 1;
	arena_air_quality= arena_air_quality + 1;
	if(arena_air_quality > 3) arena_air_quality= 0;
	ArenaResetLevel();
}
func ArenaAirQualityInfo {
	if(arena_air_quality eq 0) dmsg "CLEAN AIR HAPPY"
	if(arena_air_quality eq 1) dmsg "PURPLE HAZE"
	if(arena_air_quality eq 2) dmsg "HEAVY SMOG"
	if(arena_air_quality eq 3) dmsg "CATACLYSM"
}


########################
#  ONI TEAM ARENA 1.2  #
#  TEAMS               #
########################
var int arena_misc= 1;
var int arena_bomber= 1;
var string arena_bomber_name= mad_bomber1;
######################
func void ArenaSetupTeams(void) {
	arena_players= 1; arena_misc= 0;
	chr_unkillable(konoko, 1); chr_changeteam(konoko, Konoko);
	fork RespawnPlayer(0, Konoko, konoko, "[y.KONOKO]");
	if(arena_misc) chr_super(konoko, 1);
	sleep 100; fork AddEnemyTeam();
	sleep 50; fork AddNeutralTeam();
	sleep 50; fork AddFriendTeam();
}
func void AddFriendTeam(void) {
	AddPlayer(Konoko, ambush_commguy_2, "[y.Volt]"); sleep 150;
	AddPlayer(Konoko, ambush_commguy_1, "[y.Amp]"); sleep 150;
	AddPlayer(Konoko, Back_Striker_3, "[y.Ohm]"); sleep 150;
	AddPlayer(Konoko, tarmac_commguy_1, "[y.Current]"); sleep 150;
	AddPlayer(Konoko, Rat_Comguy_1, "[y.Circut]"); sleep 150;
	dmsg("[b.TCTF] team complete");
}
func void AddEnemyTeam(void) {
	AddPlayer(Syndicate, muro1, "[r.RED CHEIF]"); sleep 150;
	AddPlayer(Syndicate, muro2, "[r.BAIT]"); sleep 150;
	AddPlayer(Syndicate, compound_tanker_1, "[r.THE TANK]"); sleep 150;
	AddPlayer(Syndicate, escort_striker1, "[r.NAPLAM]"); sleep 150;
	AddPlayer(Syndicate, escort_striker2, "[r.Flamethrower]"); sleep 150;
	AddPlayer(Syndicate, escort_striker3, "[r.Afterburner]"); sleep 150;
	AddPlayer(Syndicate, escort_striker4, "[r.Fireball]"); sleep 150;
	AddPlayer(Syndicate, Hangar2_Striker_5, "[g.ACID]"); sleep 150;
	AddPlayer(Syndicate, mad_bomber1, "[b.C4]"); sleep 150;
	dmsg("[r.Syndicate] team complete");
	ArenaTeamsComplete();
}
func void AddNeutralTeam(void) {
	AddPlayer(Neutral, neutral_1, "[r.Citizen Smith]"); sleep 150;
	AddPlayer(Neutral, neutral_2, "[y.Citizen Jones]"); sleep 150;
	AddPlayer(Neutral, ahah_badman_1, "[b.SLD Smith]"); sleep 150;
	dmsg("[g.CITIZEN] team complete");
}


######## KILLS EVERYBODY MAC VERSION
func ArenaKillAllPlayers {
#For Konoko, we could also use her script ID, 0
chr_set_health konoko 1
sleep 1; chr_set_health ambush_commguy_2 1
sleep 10; chr_set_health ambush_commguy_1 1
sleep 1; chr_set_health Back_Striker_3 1
sleep 1; chr_set_health tarmac_commguy_1 1
sleep 1; chr_set_health Rat_Comguy_1 1
sleep 1; chr_set_health muro1 1
sleep 1; chr_set_health muro2 1
sleep 1; chr_set_health compound_tanker_1 1
sleep 1; chr_set_health escort_striker1 1
sleep 1; chr_set_health escort_striker2 1
sleep 1; chr_set_health escort_striker3 1
sleep 1; chr_set_health escort_striker4 1
sleep 1; chr_set_health Hangar2_Striker_5 1
sleep 1; chr_set_health mad_bomber1 1
sleep 1; chr_set_health neutral_1 1
sleep 1; chr_set_health neutral_2 1
sleep 1; chr_set_health ahah_badman_1 1
}

################################# MARS & VENUS
func ArenaMiscNext {
	arena_misc= arena_misc + 1; if(arena_misc > 1) arena_misc= 0;
	if(arena_misc) {
		chr_inv_reset(konoko); chr_inv_reset(muro1);
		chr_givepowerup(konoko, invis, -1);
		chr_givepowerup(muro1, invis, -1);
		chr_super(konoko, 1); chr_super(muro1, 1);
	}
	if(!arena_misc) {
		chr_inv_reset(konoko); chr_inv_reset(muro1);
		chr_super(konoko, 0); chr_super(muro1, 0);
	}
}
func ArenaMiscInfo {
	if(!arena_misc) dmsg "NOTHING SPECIAL"
	else dmsg "[r.MARS] & [b.VENUS]"
}
################################# CALLED AT EVERY FRAG
func ArenaAwareness {
	if(arena_misc) {
		chr_inv_reset(konoko); chr_inv_reset(muro1);
		sleep 1; chr_givepowerup(konoko, invis, -1);
		chr_givepowerup(muro1, invis, -1);
	}
#	if(arena_tag) {
#		ai2_attack(Lobby_TCL_1, player_name)
#		ai2_attack(Lobby_TCL_2, player_name)
#		ai2_attack(Lobby_TCS_1, player_name)
#		ai2_attack(BombTCTF1, player_name)
#		ai2_attack(BombTCTF2, player_name)
#		ai2_attack(BombComguy, player_name)
#		ai2_attack(Barabus, player_name)
#		ai2_attack(Floor1_Striker_1, player_name)
#		ai2_attack(Roof_Striker_1, player_name)
#		ai2_attack(Floor1_Striker_12, player_name)
#		ai2_attack(Lobby_Striker_2, player_name)
#		ai2_attack(Lobby_Striker_1, player_name)
#		ai2_attack(Floor2_Striker_2, player_name)
#		ai2_attack(Tower_MB_1, player_name)
#		ai2_attack(Floor1_Sci_2, player_name)
#		ai2_attack(Floor2_Sci_2, player_name)
#	}
#	else {

	ai2_makeaware(ambush_commguy_2, muro1)
	ai2_makeaware(ambush_commguy_1, muro1)
	ai2_makeaware(Back_Striker_3, muro1)
	ai2_makeaware(tarmac_commguy_1, muro1)
	ai2_makeaware(Rat_Comguy_1, muro1)
	ai2_makeaware(Hangar1_B_Comguy_12, muro1)

	ai2_makeaware(muro1, konoko)
	ai2_makeaware(muro2, konoko)
	ai2_makeaware(compound_tanker_1, konoko)
	ai2_makeaware(escort_striker1, konoko)
	ai2_makeaware(escort_striker2, konoko)
	ai2_makeaware(escort_striker3, konoko)
	ai2_makeaware(escort_striker4, konoko)
	ai2_makeaware(Hangar2_Striker_5, konoko)
	ai2_makeaware(mad_bomber1, konoko)

	ai2_makeaware(neutral_1, muro2)
	ai2_makeaware(neutral_2, muro2)
	ai2_makeaware(ahah_badman_1, muro2)
	ai2_makeaware(neutral_1, konoko)
	ai2_makeaware(neutral_2, konoko)
	ai2_makeaware(ahah_badman_1, konoko)
#	}
}
func ArenaForgetPlayer {
#	ai2_forget(Lobby_TCL_1, player_name)
#	ai2_forget(Lobby_TCL_2, player_name)
#	ai2_forget(Lobby_TCS_1, player_name)
#	ai2_forget(BombTCTF1, player_name)
#	ai2_forget(BombTCTF2, player_name)
#	ai2_forget(BombComguy, player_name)
#	ai2_forget(Barabus, player_name)
	ai2_forget(Floor1_Striker_1, player_name)
	ai2_forget(Roof_Striker_1, player_name)
	ai2_forget(Floor1_Striker_12, player_name)
	ai2_forget(Lobby_Striker_2, player_name)
	ai2_forget(Lobby_Striker_1, player_name)
	ai2_forget(Floor2_Striker_2, player_name)
	ai2_forget(Tower_MB_1, player_name)
	ai2_forget(Floor1_Sci_2, player_name)
	ai2_forget(Floor2_Sci_2, player_name)
}
################################### USED FOR BOT SHAPESHIFTING
################ PLAYERS APPEAR IN THE ORDER THEY WERE SPAWNED
func void ArenaMenuName(void) {
	if(arena_spawn_id eq  0)
		{arena_menu_name= konoko; arena_menu_nick= "[y.KONOKO]";}
	if(arena_spawn_id eq  1)
		{arena_menu_name= muro1; arena_menu_nick= "[r.RED CHIEF]";}
	if(arena_spawn_id eq  2)
		{arena_menu_name= neutral_1; arena_menu_nick= "[r.Citizen Smith]";}
	if(arena_spawn_id eq  3)
		{arena_menu_name= ambush_commguy_2; arena_menu_nick= "[y.Volt]";}
	if(arena_spawn_id eq  4)
		{arena_menu_name= muro2; arena_menu_nick= "[r.BAIT]";}
	if(arena_spawn_id eq  5)
		{arena_menu_name= neutral_2; arena_menu_nick= "[y.Citizen Jones]";}
	if(arena_spawn_id eq  6)
		{arena_menu_name= ambush_commguy_1; arena_menu_nick= "[y.Amp]";}
	if(arena_spawn_id eq  7)
		{arena_menu_name= compound_tanker_1; arena_menu_nick= "[r.THE TANK]";}
	if(arena_spawn_id eq  8)
		{arena_menu_name= ahah_badman_1; arena_menu_nick= "[b.SLD Smith]";}
	if(arena_spawn_id eq  9)
		{arena_menu_name= Back_Striker_3; arena_menu_nick= "[y.Ohm]";}
	if(arena_spawn_id eq 10)
		{arena_menu_name= escort_striker1; arena_menu_nick= "[r.NAPLAM]";}
	if(arena_spawn_id eq 11)
		{arena_menu_name= tarmac_commguy_1; arena_menu_nick= "[y.Current]";}
	if(arena_spawn_id eq 12)
		{arena_menu_name= escort_striker2; arena_menu_nick= "[r.Flamethrower]";}
	if(arena_spawn_id eq 13)
		{arena_menu_name= Rat_Comguy_1; arena_menu_nick= "[y.Circut]";}
	if(arena_spawn_id eq 14)
		{arena_menu_name= escort_striker3; arena_menu_nick= "[r.Afterburner]";}
	if(arena_spawn_id eq 15)
		{arena_menu_name= Hangar1_B_Comguy_12; arena_menu_nick= "[b.Battery]";}
	if(arena_spawn_id eq 16)
		{arena_menu_name= escort_striker4; arena_menu_nick= "[r.Fireball]";}
	if(arena_spawn_id eq 17)
		{arena_menu_name= compound_bomber_1; arena_menu_nick= "[o.Bomber 01]";}
	if(arena_spawn_id eq 18)
		{arena_menu_name= Hangar2_Striker_5; arena_menu_nick= "[g.ACID]";}
	if(arena_spawn_id eq 19)
		{arena_menu_name= cruel_striker1; arena_menu_nick= "[b.C4]";}
}



########################
#  ONI TEAM ARENA 1.2  #
#  WAEAPON             #
########################
################ WEAPON VARIABLES (CORE)
var int arena_gun_mode= 1;
var int weapons_spawned= 0; var int can_give_weapon= 0;
var int fixed_weapon= 0; var int fixed_weapon_max;
################ MAX NUMBER OF WEAPONS (CUSTOM)
var int max_weapons= 20;
################ RESET WEAPONS (CUSTOM, CAN BE AREA-DEPENDENT)
func void ArenaResetWeapons(void) {
	weapons_spawned= 0; max_weapons= 8;
	if(arena_gun_mode > 5) max_weapons= 4;
	fixed_weapon_max= 8;
	can_give_weapon= 0;
#	weapon_reset();
}


################
func void ArenaGunsNextMode(void) {
	arena_gun_mode= arena_gun_mode + 1;
	if(arena_gun_mode > 10) arena_gun_mode= 0;
}
func void ArenaGunsInfo(void) {
	if(arena_gun_mode eq  0) dmsg "No guns"	
	if(arena_gun_mode eq  1) dmsg "Mixed guns given at respawn"
	if(arena_gun_mode eq  2) dmsg "VDGs given at respawn"
	if(arena_gun_mode eq  3) dmsg "CEs given at respawn"
	if(arena_gun_mode eq  4) dmsg "PRs given at respawn"
	if(arena_gun_mode eq  5) dmsg "MBs given at respawn"
	if(arena_gun_mode eq  6) dmsg "Mixed guns lying on the ground"
	if(arena_gun_mode eq  7) dmsg "VDGs lying on the ground"
	if(arena_gun_mode eq  8) dmsg "CEs lying on the ground"
	if(arena_gun_mode eq  9) dmsg "PRs lying on the ground"
	if(arena_gun_mode eq 10) dmsg "MBs lying on the ground"
}
################ MODERATOR (CUSTOM)
func void ArenaWeaponModerator(int frags) {
	if(frags eq  10) ArenaAddWeapon();
	if(frags eq  20) ArenaAddWeapon();
	if(frags eq  30) ArenaAddWeapon();
	if(frags eq  40) ArenaAddWeapon();
	if(frags eq  50) ArenaAddWeapon();
	if(frags eq  60) ArenaAddWeapon();
	if(frags eq  70) ArenaAddWeapon();
	if(frags eq  80) ArenaAddWeapon();
	if(frags eq  90) ArenaAddWeapon();
	if(frags eq 100) ArenaAddWeapon();
	if(frags eq 110) ArenaAddWeapon();
	if(frags eq 120) ArenaAddWeapon();
	if(frags eq 130) ArenaAddWeapon();
	if(frags eq 140) ArenaAddWeapon();
	if(frags eq 150) ArenaAddWeapon();
	if(frags eq 160) ArenaAddWeapon();
	if(frags eq 170) ArenaAddWeapon();
	if(frags eq 180) ArenaAddWeapon();
	if(frags eq 190) ArenaAddWeapon();
	if(frags eq 200) ArenaAddWeapon();
}
################ ADD NEW WEAPON (CORE)
func void ArenaAddWeapon(void) {
	RandWeapon()
	if(arena_gun_mode eq 2 or arena_gun_mode eq  7) rand_weapon_name= w6_vdg
	if(arena_gun_mode eq 3 or arena_gun_mode eq  8) rand_weapon_name= w1_tap
	if(arena_gun_mode eq 4 or arena_gun_mode eq  9) rand_weapon_name= w3_phr
	if(arena_gun_mode eq 5 or arena_gun_mode eq 10) rand_weapon_name= w8_mbo
	if(arena_gun_mode > 0 and arena_gun_mode < 6) can_give_weapon= 1;
	if(arena_gun_mode > 5) fork SpawnFixedWeapon();
}
######## GIVEN WEAPON (CORE)
func void GiveRandWeapon(string ai_name) {
	if(can_give_weapon eq 1 and weapons_spawned < max_weapons) {
		can_give_weapon= 0; weapons_spawned= weapons_spawned + 1;
		chr_giveweapon(ai_name, rand_weapon_name);
	}
}
######## FIXED WEAPON (LEVEL- AND AREA-DEPENDENT) 
func void SpawnFixedWeapon(void) {
	if(rand_weapon_name eq w11_ba1) rand_weapon_name= w6_vdg
	if(weapons_spawned < max_weapons) {
		weapons_spawned= weapons_spawned + 1;
		fixed_weapon= fixed_weapon + 1;
		if(fixed_weapon > fixed_weapon_max) fixed_weapon= 0;
		if(arena_area eq 0) {
			if(fixed_weapon eq 0) weapon_spawn(rand_weapon_name, 0)
			if(fixed_weapon eq 1) weapon_spawn(rand_weapon_name, 101)
			if(fixed_weapon eq 2) weapon_spawn(rand_weapon_name, 102)
			if(fixed_weapon eq 3) weapon_spawn(rand_weapon_name, 103)
			if(fixed_weapon eq 4) weapon_spawn(rand_weapon_name, 104)
			if(fixed_weapon eq 5) weapon_spawn(rand_weapon_name, 107)
			if(fixed_weapon eq 6) weapon_spawn(rand_weapon_name, 110)
			if(fixed_weapon eq 7) weapon_spawn(rand_weapon_name, 115)
			if(fixed_weapon eq 8) weapon_spawn(rand_weapon_name, 200)
		}
		if(arena_area eq 1) {
			if(fixed_weapon eq 0) weapon_spawn(rand_weapon_name, 188)
			if(fixed_weapon eq 1) weapon_spawn(rand_weapon_name, 191)
			if(fixed_weapon eq 2) weapon_spawn(rand_weapon_name, 195)
			if(fixed_weapon eq 3) weapon_spawn(rand_weapon_name, 7091)
			if(fixed_weapon eq 4) weapon_spawn(rand_weapon_name, 7092)
			if(fixed_weapon eq 5) weapon_spawn(rand_weapon_name, 7093)
			if(fixed_weapon eq 6) weapon_spawn(rand_weapon_name, 7095)
			if(fixed_weapon eq 7) weapon_spawn(rand_weapon_name, 7096)
			if(fixed_weapon eq 8) weapon_spawn(rand_weapon_name, 188)
		}
		if(arena_area eq 2) {
			if(fixed_weapon eq 0) weapon_spawn(rand_weapon_name, 266)
			if(fixed_weapon eq 1) weapon_spawn(rand_weapon_name, 267)
			if(fixed_weapon eq 2) weapon_spawn(rand_weapon_name, 268)
			if(fixed_weapon eq 3) weapon_spawn(rand_weapon_name, 269)
			if(fixed_weapon eq 4) weapon_spawn(rand_weapon_name, 270)
			if(fixed_weapon eq 5) weapon_spawn(rand_weapon_name, 271)
			if(fixed_weapon eq 6) weapon_spawn(rand_weapon_name, 272)
			if(fixed_weapon eq 7) weapon_spawn(rand_weapon_name, 273)
			if(fixed_weapon eq 8) weapon_spawn(rand_weapon_name, 7094)
		}
		
	}
}

########################
#  ONI TEAM ARENA 1.2  #
#  RANDOM              #
########################
################ FRAMES SINCE LAST RESTART
var int arena_time= 0;
################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag1= 0; var int rand_flag2= 0;
var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag1_max= 10; var int rand_flag2_max= 11;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 1;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	if(next_tune ne now_playing) {
		sound_music_stop(now_playing); now_playing= next_tune; 
		sleep 400; sound_music_start(now_playing);
	}
	sleep 4000; fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= mus_asian; next_tune= mus_asian;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) {rand_flag1_max= 9; rand_flag2_max= 9;}
	if(arena_area eq 1) {rand_flag1_max= 4; rand_flag2_max= 4;}
	if(arena_area eq 2) {rand_flag1_max= 5; rand_flag2_max= 5;}
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag1= rand_flag1 + 1; if(rand_flag1 > rand_flag1_max) rand_flag1= 0;
	rand_flag2= rand_flag2 + 1; if(rand_flag2 > rand_flag2_max) rand_flag2= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;

	arena_time= arena_time + 1;
	if(arena_limit eq 1 and arena_time eq 9600) sound_ambient_start alarm_loop
	if(arena_limit eq 2 and arena_time eq 16800) sound_ambient_start alarm_loop
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_main01;
	if(rand_music eq 1) next_tune= mus_main03;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(int ai_id, string ai_name, string ai_team) {
	if(ai_team ne Konoko and ai_team ne Syndicate) {
		if(rand_flag1 > rand_flag2) ai_team= Konoko
		else                     ai_team= Syndicate
	}
################ BLUELINE
	if(arena_area eq 0) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq  0)
			{chr_teleport(ai_name,   0); chr_facetoflag(ai_name,     0);}
		if(rand_flag1 eq  1)
			{chr_teleport(ai_name,   101); chr_facetoflag(ai_name,   101);}
		if(rand_flag1 eq  2)
			{chr_teleport(ai_name,   104); chr_facetoflag(ai_name,   104);}
		if(rand_flag1 eq  3)
			{chr_teleport(ai_name,   107); chr_facetoflag(ai_name,   107);}
		if(rand_flag1 eq  4)
			{chr_teleport(ai_name,   118); chr_facetoflag(ai_name,   118);}
		if(rand_flag1 eq  5)
			{chr_teleport(ai_name,   197); chr_facetoflag(ai_name,   197);}
		if(rand_flag1 eq  6)
			{chr_teleport(ai_name,   198); chr_facetoflag(ai_name,   198);}
		if(rand_flag1 eq  7)
			{chr_teleport(ai_name,   199); chr_facetoflag(ai_name,   199);}
		if(rand_flag1 eq  8)
			{chr_teleport(ai_name,   200); chr_facetoflag(ai_name,   200);}
		if(rand_flag1 eq  9)
			{chr_teleport(ai_name,   108); chr_facetoflag(ai_name,   108);}
		if(rand_flag1 > 9)
			{chr_teleport(ai_name,   109); chr_facetoflag(ai_name,   109);}
			
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq 0)
			{chr_teleport(ai_name,   110); chr_facetoflag(ai_name,   110);}
		if(rand_flag2 eq 1)
			{chr_teleport(ai_name,   111); chr_facetoflag(ai_name,   111);}
		if(rand_flag2 eq 2)
			{chr_teleport(ai_name,   112); chr_facetoflag(ai_name,   112);}
		if(rand_flag2 eq 3)
			{chr_teleport(ai_name,   113); chr_facetoflag(ai_name,   113);}
		if(rand_flag2 eq 4)
			{chr_teleport(ai_name,   114); chr_facetoflag(ai_name,   114);}
		if(rand_flag2 eq 5)
			{chr_teleport(ai_name,   115); chr_facetoflag(ai_name,   115);}
		if(rand_flag2 eq 6)
			{chr_teleport(ai_name,   116); chr_facetoflag(ai_name,   116);}
		if(rand_flag2 eq 7)
			{chr_teleport(ai_name,   117); chr_facetoflag(ai_name,   117);}
		if(rand_flag2 eq 8)
			{chr_teleport(ai_name,   7000); chr_facetoflag(ai_name,  7000);}
		if(rand_flag2 eq 9)
			{chr_teleport(ai_name,   7010); chr_facetoflag(ai_name,  7010);}
		if(rand_flag2 > 9)
			{chr_teleport(ai_name,   7121); chr_facetoflag(ai_name,  7121);}
			
		}
	}
################ AIRPLANE
	if(arena_area eq 1) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 188); chr_facetoflag(ai_name,  188);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 191); chr_facetoflag(ai_name,  191);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 195); chr_facetoflag(ai_name,  195);}
			if(rand_flag1 > 2)
				{chr_teleport(ai_name, 7091); chr_facetoflag(ai_name, 7091);}
			
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name, 7092); chr_facetoflag(ai_name, 7092);}
			if(rand_flag2 eq  1)
				{chr_teleport(ai_name, 7093); chr_facetoflag(ai_name, 7093);}
			if(rand_flag2 eq  2)
				{chr_teleport(ai_name, 7095); chr_facetoflag(ai_name, 7095);}
			if(rand_flag2 >  2)
				{chr_teleport(ai_name, 7096); chr_facetoflag(ai_name, 7096);}
			
		}
	}
################ LOBBYMEN
	if(arena_area eq 2) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name,   266); chr_facetoflag(ai_name,   266);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name,   267); chr_facetoflag(ai_name,   267);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name,   268); chr_facetoflag(ai_name,   268);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name,   269); chr_facetoflag(ai_name,   269);}
			if(rand_flag1 > 3)
				{chr_teleport(ai_name,   270); chr_facetoflag(ai_name,   270);}
			
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name,   271); chr_facetoflag(ai_name,   271);}
			if(rand_flag2 eq  1)
				{chr_teleport(ai_name,   272); chr_facetoflag(ai_name,   272);}
			if(rand_flag2 eq  2)
				{chr_teleport(ai_name,   273); chr_facetoflag(ai_name,   273);}
			if(rand_flag2 eq  3)
				{chr_teleport(ai_name,   7094); chr_facetoflag(ai_name, 7094);}
			if(rand_flag2 >  3)
				{chr_teleport(ai_name,   7098); chr_facetoflag(ai_name, 7098);}
			
		}
	}

################ HEAVEN ELEVEN
	chr_animate(ai_name, KONCOMsuper_kick);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}

########################
#  ONI TEAM ARENA 1.2  #
#  SCORE               #
########################
var int friend_sc; var int enemy_sc;
var int friend_lt; var int enemy_lt;
var int friend_xl; var int enemy_xl;
var int friend_ld; var int enemy_ld; 
var int arena_limit= 1;
#####################################
func void ArenaResetScore(void) {
 	cinematic_stop(KONtransform, 15, 30)
# 	cinematic_stop(MUROevilgrin, 16, 30)
 	cinematic_stop(BOSS1talking, 16, 30)
#	if((save_point) eq 0) arena_limit= -1;
#	if((save_point) eq 1) arena_limit= 1;
	sound_ambient_stop alarm_loop
	friend_sc=   0; enemy_sc=   0;
	friend_lt= 100; enemy_lt= 100;
	friend_xl=   0; enemy_xl=   0;
	friend_ld=   0; enemy_ld=   0;
	if(arena_limit eq -1) {friend_lt= 50; enemy_lt= 50;}
	arena_scoring= 1; arena_time= 0;
	if(arena_limit > 0) {
		friend_lt= 100; enemy_lt= 100;
		if(arena_limit eq 1) timer_start 180 ArenaTimeOut
# Note 180 timer start original 3 minutes		
		if(arena_limit eq 2) timer_start 300 ArenaTimeOut
	}
}
################ ARENA DESCRIPTION (CUSTOM)
func void ArenaScoreInfo(void) {
	if(arena_limit eq -1) dmsg("50 FRAGS = VICTORY");
	if(arena_limit eq 0) dmsg("100 FRAGS = VICTORY");
	if(arena_limit eq 1) dmsg("TIME LIMIT : 3 MINUTES")
	if(arena_limit eq 2) dmsg("TIME LIMIT : 5 MINUTES")
}
func void ArenaScoreNextMode(void) {
	arena_limit= arena_limit + 1;
	if(arena_limit > 2) arena_limit= -1;
}
################ DEATH REGISTRATION (CORE, CUSTOM MESSAGES)
func void Death(string ai_team, string ai_name, string ai_nick) {
	dmsg(" "); dmsg(ai_nick); RandDead(); chr_pain(ai_name, death);
	if(ai_team ne Konoko and ai_team ne Syndicate) {
		dmsg(" "); dmsg("WHO CARES?");
	} 
	if(ai_team eq Syndicate) {
 		cinematic_stop(MUROevilgrin, 16, 10)
		friend_sc= friend_sc + 1
		friend_lt= friend_lt - 1; if(friend_lt eq 0) dmsg " "
		friend_xl= friend_xl + 1; enemy_xl= 0
		friend_ld= enemy_lt - friend_lt
		dmsg "[g.TCTF]"
	     	     if(friend_lt < 6 and enemy_lt > friend_lt)
			LeftMess(Konoko, friend_lt)
		else if(friend_ld eq 0 or friend_ld eq 1)
			LeadMess(Konoko, friend_ld)
		else    ExcelMess(Konoko, friend_xl)
	}
	if(ai_team eq Konoko) {
 		cinematic_stop(KONtransform, 15, 10)
		enemy_sc= enemy_sc + 1
		enemy_lt= enemy_lt - 1; if(enemy_lt eq 0) dmsg " "
		enemy_xl= enemy_xl + 1; friend_xl= 0
		enemy_ld= friend_lt - enemy_lt 
		dmsg "[r.Syndicate]"
	     	     if(enemy_lt < 6 and friend_lt > enemy_lt)
			LeftMess(Syndicate, enemy_lt)
		else if(enemy_ld eq 0 or enemy_ld eq 1)
			LeadMess(Syndicate, enemy_ld)
		else    ExcelMess(Syndicate, enemy_xl)
	}
	if(chr_is_player(ai_name)) {
		dmsg " "
		dmsg "[g.TCTF] :"
		PrintScore(friend_sc)
		dmsg "[r.Syndicate] :"
		PrintScore(enemy_sc)
	}
	ArenaWeaponModerator(enemy_sc + friend_sc);
}
################ TIME LIMIT
func ArenaTimeOut {
	arena_scoring= 0; timer_stop
	sound_impulse_play door_lock
	sound_impulse_play killkick
	ai2_allpassive(1); p3_removedangerous();
	dmsg " "
	dmsg "[g.TCTF] :"
	PrintScore(friend_sc)
	dmsg "[r.Syndicate] :"
	PrintScore(enemy_sc)
	sleep 30; sound_dialog_play c18_73_09madbomb 5.0
	sleep 90
	dmsg " "
	if(friend_sc > enemy_sc) {
		dmsg("[g.TCTF]");
		dmsg("WIN THE FIGHT!"); fork GameOver(Konoko);
	}
	if(friend_sc < enemy_sc) {
		dmsg("[r.Syndicate]");
		dmsg("WIN THE FIGHT!"); fork GameOver(Syndicate);
	}
	if(friend_sc eq enemy_sc) {
		dmsg("[b.TEAMS ARE TIED]"); dmsg(" "); fork GameOver(NoTeam);
	}
}
################ FRAGS LEFT MESSAGE
func LeftMess(string team_name, int frags_left) {
	sound_impulse_play door_lock
	sound_impulse_play killkick
	if(frags_left eq 5) {
		dmsg "are [y.5 FRAGS] away from victory!"
		sleep 10
		if(team_name eq Konoko) {
			sound_dialog_play c17_99_28konoko
 			cinematic_stop(KONtransform, 15, 10)
		}
		if(team_name eq Syndicate) {
			sound_dialog_play c17_99_02striker
 			cinematic_stop(MUROevilgrin, 16, 10)
		}
	}
	if(frags_left eq 4) dmsg "are [y.4 FRAGS] away from victory!"
	if(frags_left eq 3) dmsg "are [y.3 FRAGS] away from victory!"
	if(frags_left eq 2) dmsg "are [y.2 FRAGS] away from victory!"
	if(frags_left eq 1) {
		dmsg "are [y.1 FRAG] away from victory!"
		sound_ambient_start alarm_loop
	}
	if(frags_left eq 0) ArenaTimeOut();
}
func void GameOver(string team_name) {
 	cinematic_stop(KONtransform, 15, 30)
 	cinematic_stop(MUROevilgrin, 16, 30)
	sound_ambient_stop alarm_loop
	arena_scoring= 0;
	ai2_allpassive(1); p3_removedangerous();
	if(team_name eq Konoko) {
		sound_dialog_play c17_99_28konoko
 		cinematic_start(KONtransform, 128, 128, 15, 1, 10, false)
		chr_animate(0, KONOKOendpowerup)
	}
	if(team_name eq Syndicate) {
		sound_dialog_play c18_73_02striker
		cinematic_start(MUROevilgrin, 128, 128, 16, 3, 10, true)
	}
	if(team_name ne Konoko and team_name ne Syndicate) {
 		cinematic_start(KONtransform, 128, 128, 15, 1, 30, false)
 		cinematic_start(MUROevilgrin, 128, 128, 16, 3, 30, true)
	}	
	dmsg "[r.Thank you for playing the arena!]"
	dmsg "geyser@oni2.net"
	sleep 180
	fork ArenaReset(1);
	sleep 100;  ai2_allpassive(0);
#	ArenaAllActive();
}
################ LEAD MESSAGE (LEVEL-SPECIFIC SOUNDS, CUSTOM MESSAGES)
func LeadMess(string team_name, int lead_swap) {
	sound_impulse_play door_lock
	sound_impulse_play killkick
	if(lead_swap) {
		dmsg "HAVE [r.TAKEN THE LEAD]"
		sleep 10
		if(team_name eq Konoko) {
			sound_dialog_play c17_99_28konoko
 			cinematic_start(KONtransform, 128, 128, 15, 1, 30, false)
		}
		if(team_name eq Syndicate) {
			sound_dialog_play c17_99_02striker
			cinematic_stop(MUROevilgrin, 16, 30)
		}
	}
	if(!lead_swap) dmsg "HAVE [y.TIED FOR THE LEAD]"
}
################ EXCELLENCE MESSAGE (LEVEL-SPECIFIC SOUNDS, CUSTOM MESSAGES)
func ExcelMess(string team_name, int xl_frags) {
	if(xl_frags eq 1) dmsg "SCORE"
	if(xl_frags eq 2) {
		dmsg "ARE IMPRESSIVE!"
		sound_impulse_play objective_complete
	}
	if(xl_frags eq 3) {
		dmsg "ARE EXCELLENT!"
		sound_impulse_play objective_prompt
	}		
	if(xl_frags eq 4) {
		dmsg "ARE UNSTOPPABLE!"
		sound_impulse_play objective_new
	}
	if(xl_frags eq 5) {
		dmsg "ARE GODLIKE!"
		sound_impulse_play killkick
		sleep 10
		if(team_name eq Konoko) {
			sound_dialog_play c17_99_28konoko
			cinematic_start(KONtransform, 128, 128, 15, 1, 30, false)
		}
		if(team_name eq Syndicate) {
			sound_dialog_play c17_99_18comguy
 			cinematic_start(MUROevilgrin, 128, 128, 16, 3, 30, true)
		}
	}
	if(xl_frags > 5) {
		dmsg "ARE [r.TRULY] GODLIKE!!!"
		sound_impulse_play killkick
		if(team_name eq Syndicate) {
			sound_dialog_play c17_99_02striker
 			cinematic_start(MUROevilgrin, 128, 128, 16, 3, 30, false)
		}
	}
}
func PrintScore(int score) {
	if(score eq   0) dmsg "0"
	if(score eq   1) dmsg "1"
	if(score eq   2) dmsg "2"
	if(score eq   3) dmsg "3"
	if(score eq   4) dmsg "4"
	if(score eq   5) dmsg "5"
	if(score eq   6) dmsg "6"
	if(score eq   7) dmsg "7"
	if(score eq   8) dmsg "8"
	if(score eq   9) dmsg "9"
	if(score eq  10) dmsg "10"
	if(score eq  11) dmsg "11"
	if(score eq  12) dmsg "12"
	if(score eq  13) dmsg "13"
	if(score eq  14) dmsg "14"
	if(score eq  15) dmsg "15"
	if(score eq  16) dmsg "16"
	if(score eq  17) dmsg "17"
	if(score eq  18) dmsg "18"
	if(score eq  19) dmsg "19"
	if(score eq  20) dmsg "20"
	if(score eq  21) dmsg "21"
	if(score eq  22) dmsg "22"
	if(score eq  23) dmsg "23"
	if(score eq  24) dmsg "24"
	if(score eq  25) dmsg "25"
	if(score eq  26) dmsg "26"
	if(score eq  27) dmsg "27"
	if(score eq  28) dmsg "28"
	if(score eq  29) dmsg "29"
	if(score eq  30) dmsg "30"
	if(score eq  31) dmsg "31"
	if(score eq  32) dmsg "32"
	if(score eq  33) dmsg "33"
	if(score eq  34) dmsg "34"
	if(score eq  35) dmsg "35"
	if(score eq  36) dmsg "36"
	if(score eq  37) dmsg "37"
	if(score eq  38) dmsg "38"
	if(score eq  39) dmsg "39"
	if(score eq  40) dmsg "40"
	if(score eq  41) dmsg "41"
	if(score eq  42) dmsg "42"
	if(score eq  43) dmsg "43"
	if(score eq  44) dmsg "44"
	if(score eq  45) dmsg "45"
	if(score eq  46) dmsg "46"
	if(score eq  47) dmsg "47"
	if(score eq  48) dmsg "48"
	if(score eq  49) dmsg "49"
	if(score eq  50) dmsg "50"
	if(score eq  51) dmsg "51"
	if(score eq  52) dmsg "52"
	if(score eq  53) dmsg "53"
	if(score eq  54) dmsg "54"
	if(score eq  55) dmsg "55"
	if(score eq  56) dmsg "56"
	if(score eq  57) dmsg "57"
	if(score eq  58) dmsg "58"
	if(score eq  59) dmsg "59"
	if(score eq  60) dmsg "60"
	if(score eq  61) dmsg "61"
	if(score eq  62) dmsg "62"
	if(score eq  63) dmsg "63"
	if(score eq  64) dmsg "64"
	if(score eq  65) dmsg "65"
	if(score eq  66) dmsg "66"
	if(score eq  67) dmsg "67"
	if(score eq  68) dmsg "68"
	if(score eq  69) dmsg "69"
	if(score eq  70) dmsg "70"
	if(score eq  71) dmsg "71"
	if(score eq  72) dmsg "72"
	if(score eq  73) dmsg "73"
	if(score eq  74) dmsg "74"
	if(score eq  75) dmsg "75"
	if(score eq  76) dmsg "76"
	if(score eq  77) dmsg "77"
	if(score eq  78) dmsg "78"
	if(score eq  79) dmsg "79"
	if(score eq  80) dmsg "80"
	if(score eq  81) dmsg "81"
	if(score eq  82) dmsg "82"
	if(score eq  83) dmsg "83"
	if(score eq  84) dmsg "84"
	if(score eq  85) dmsg "85"
	if(score eq  86) dmsg "86"
	if(score eq  87) dmsg "87"
	if(score eq  88) dmsg "88"
	if(score eq  89) dmsg "89"
	if(score eq  90) dmsg "90"
	if(score eq  91) dmsg "91"
	if(score eq  92) dmsg "92"
	if(score eq  93) dmsg "93"
	if(score eq  94) dmsg "94"
	if(score eq  95) dmsg "95"
	if(score eq  96) dmsg "96"
	if(score eq  97) dmsg "97"
	if(score eq  98) dmsg "98"
	if(score eq  99) dmsg "99"
	if(score eq 100) dmsg "100"
}

########################
#  ONI TEAM ARENA 1.2  #
#  MENU                #
########################
# The menu provides advanced functionality like :
# -changing the gun mode
# -changing the frag/time limit
# -changing the "air quality"
# -enabling "today's specials"
############
var int arena_menu= 0;
var string arena_menu_name; var string arena_menu_nick;
############ 
func void ArenaAdvanced(void) {
	arena_menu= 0; arena_spawn_id= 0; ArenaMenuName();
	sleep 30; 
	fork ArenaF2(); 
	fork ArenaF3(); 
	fork ArenaCycler();
}
######## AREA CYCLER (CORE)
func void ArenaF3(void) {
	chr_wait_animation(0, KONOKOjump_bk_punch);
	if(!arena_menu) fork ArenaReset(1);
	else            fork ArenaReset(0);
	sleep 60; fork ArenaF3();
}
######## BOT SHAPESHIFTER (CORE)
func void ArenaF2(void) {
	chr_wait_animation 0 KONOKOjump_bk_crouch
	ai2_allpassive(1); p3_removedangerous();
	arena_scoring= 0; chr_draw_all_characters= 1; arena_menu= 1;
	arena_spawn_id= 0; ArenaMenuName();
		dmsg(" "); PrintPlayer(arena_spawn_id); dmsg(arena_menu_nick);
		dmsg("SHAPESHIFTER - PC Only");  dmsg("Kick = Next option");
	sleep 161; chr_wait_animtype(0, kick);
	arena_menu= 2; chr_draw_all_characters= 0;
		dmsg(" "); dmsg("[r.TOOLS OF DEATH]"); ArenaGunsInfo();
		dmsg("Punch = Next weapon mode"); dmsg("Kick = Next option");
	sleep 161; chr_wait_animtype(0, kick);
	arena_menu= 3;
		dmsg(" "); dmsg("[b.TIME/FRAG LIMIT]"); ArenaScoreInfo();
		dmsg("Punch = Next time/frag mode"); dmsg("Kick = Next option");
	sleep 161; chr_wait_animtype(0, kick);
	arena_menu= 4;
		dmsg(" "); dmsg("[y.AIR QUALITY]"); ArenaAirQualityInfo();
		dmsg("Punch = Next quality"); dmsg("Kick = Next option");
	sleep 161; chr_wait_animtype(0, kick);
	arena_menu= 5;
		dmsg(" "); dmsg("[o.TODAY'S SPECIALS]"); ArenaMiscInfo();
		dmsg("Punch = Next special"); dmsg("Kick = Back to game");
	sleep 161; chr_wait_animtype(0, kick);
	arena_menu= 0; ai2_allpassive(0); arena_scoring= 1; fork ArenaAreaInfo();
	sleep 161; fork ArenaF2();
}
######## CYCLER (CORE)
func void ArenaCycler(void) {
	chr_wait_animtype(0, punch);
	if(arena_menu eq 1) {
#		ai2_takecontrol(1); chr_neutral(arena_menu_name, 0);
#		arena_spawn_id= arena_spawn_id + 1;
#		if(arena_spawn_id >= arena_players) arena_spawn_id= 0; 
#		ArenaMenuName();
#		dmsg(" "); PrintPlayer(arena_spawn_id); 
#		#dmsg(arena_menu_nick);
		dmsg("SHAPESHIFTER - PC Only");
		dmsg("Kick = next menu");
#		if(arena_spawn_id) dmsg("[y.DO] USE [b.CHEAT CODES]!!!");
#		else dmsg("F2 = next menu | F3 = restart");
#		chr_focus(arena_spawn_id);
#		chr_neutral(arena_menu_name, 1); ai2_takecontrol(0);
#		chr_dontaim(arena_menu_name, 0);
#		chr_debug_target= arena_spawn_id;
	}
	if(arena_menu eq 2) {
		dmsg(" "); dmsg("[r.TOOLS OF DEATH]");
		ArenaGunsNextMode(); ArenaGunsInfo();
		dmsg("Punch = Next weapon mode");
		dmsg("Kick = Next option");
	}
	if(arena_menu eq 3) {
		dmsg(" "); dmsg("[b.TIME/FRAG LIMIT]");
		ArenaScoreNextMode(); ArenaScoreInfo();
		dmsg("Punch = Next time/frag mode");
		dmsg("Kick = Next option");
	}
	if(arena_menu eq 4) {
		dmsg(" "); dmsg("[y.AIR QUALITY]");
		ArenaAirQualityNext(); ArenaAirQualityInfo();
		dmsg("Punch = Next quality");
		dmsg("Kick = Next option");
	}
	if(arena_menu eq 5) {
		dmsg(" "); dmsg("[o.TODAY'S SPECIALS]");
		ArenaMiscNext(); ArenaMiscInfo();
		dmsg("Punch = Next special");
		dmsg("Kick = Back to game");
	}
	sleep 30; fork ArenaCycler();
}
######## PRINTS PLAYER INDEX (FOR BOT SHAPESHIFTING)
func void PrintPlayer(int player_id) {
	if(player_id eq 0) dmsg("PLAYER 0:");
	if(player_id eq 1) dmsg("PLAYER 1:");
	if(player_id eq 2) dmsg("PLAYER 2:");
	if(player_id eq 3) dmsg("PLAYER 3:");
	if(player_id eq 4) dmsg("PLAYER 4:");
	if(player_id eq 5) dmsg("PLAYER 5:");
	if(player_id eq 6) dmsg("PLAYER 6:");
	if(player_id eq 7) dmsg("PLAYER 7:");
	if(player_id eq 8) dmsg("PLAYER 8:");
	if(player_id eq 9) dmsg("PLAYER 9:");
	if(player_id eq 10) dmsg("PLAYER 10:");
	if(player_id eq 11) dmsg("PLAYER 11:");
	if(player_id eq 12) dmsg("PLAYER 12:");
	if(player_id eq 13) dmsg("PLAYER 13:");
	if(player_id eq 14) dmsg("PLAYER 14:");
	if(player_id eq 15) dmsg("PLAYER 15:");
	if(player_id eq 16) dmsg("PLAYER 16:");
	if(player_id eq 17) dmsg("PLAYER 17:");
	if(player_id eq 18) dmsg("PLAYER 18:");
	if(player_id eq 19) dmsg("PLAYER 19:");
	if(player_id eq 20) dmsg("PLAYER 20:");
	if(player_id eq 21) dmsg("PLAYER 21:");
}
