########################
#  ONI TEAM ARENA 1.1  #
#  A. C. C. INTERIOR   #
########################
################ FRAMES SINCE LAST RESTART
var int arena_time= 0;
################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag1= 0; var int rand_flag2= 0;
var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 24; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag1_max= 11; var int rand_flag2_max= 11;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 5;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	if(next_tune ne now_playing) {
		sound_music_stop(now_playing); now_playing= next_tune; 
		sleep 400; sound_music_start(now_playing);
	}
	sleep 4000; fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= mus_lz; next_tune= mus_trt;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) {rand_flag1_max= 10; rand_flag2_max= 10;}
	if(arena_area eq 1) {rand_flag1_max= 10; rand_flag2_max= 11;}
	if(arena_area eq 2) {rand_flag1_max= 4; rand_flag2_max= 5;}
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag1= rand_flag1 + 1; if(rand_flag1 > rand_flag1_max) rand_flag1= 0;
	rand_flag2= rand_flag2 + 1; if(rand_flag2 > rand_flag2_max) rand_flag2= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;

	arena_time= arena_time + 1;
	if(arena_limit eq 1 and arena_time eq 9600) sound_ambient_start alarm_loop
	if(arena_limit eq 2 and arena_time eq 16800) sound_ambient_start alarm_loop
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_lz;
	if(rand_music eq 1) next_tune= mus_xtr2;
	if(rand_music eq 2) next_tune= mus_trt;
	if(rand_music eq 3) next_tune= mus_amasian;
	if(rand_music eq 4) next_tune= atm_cl11;
	if(rand_music eq 5) next_tune= atm_cl12;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(int ai_id, string ai_name, string ai_team) {
	if(ai_team ne Konoko and ai_team ne Syndicate) {
		if(rand_flag1 > rand_flag2) ai_team= Konoko
		else                     ai_team= Syndicate
	}
################ ACC2 : CIRCULAR LOGIC
	if(arena_area eq 0) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq  0)
				{chr_teleport(ai_name,   78); chr_facetoflag(ai_name,   78);}
			if(rand_flag1 eq  1)
    			{chr_teleport(ai_name,   80); chr_facetoflag(ai_name,   80);}
    		if(rand_flag1 eq  2)
    			{chr_teleport(ai_name,   82); chr_facetoflag(ai_name,   82);}
    		if(rand_flag1 eq  3)
    			{chr_teleport(ai_name,   84); chr_facetoflag(ai_name,   84);}
    		if(rand_flag1 eq  4)
    			{chr_teleport(ai_name,   86); chr_facetoflag(ai_name,   86);}
    		if(rand_flag1 eq  5)
    			{chr_teleport(ai_name,   88); chr_facetoflag(ai_name,   88);}
    		if(rand_flag1 eq  6)
    			{chr_teleport(ai_name,   90); chr_facetoflag(ai_name,   90);}
    		if(rand_flag1 eq  7)
    			{chr_teleport(ai_name,   92); chr_facetoflag(ai_name,   92);}
    		if(rand_flag1 eq  8)
    			{chr_teleport(ai_name,   94); chr_facetoflag(ai_name,   94);}
    		if(rand_flag1 eq  9)
    			{chr_teleport(ai_name,   96); chr_facetoflag(ai_name,   96);}
    		if(rand_flag1 >  9)
    			{chr_teleport(ai_name,   98); chr_facetoflag(ai_name,   98);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name,   79); chr_facetoflag(ai_name,   79);}
    		if(rand_flag2 eq  1)
    			{chr_teleport(ai_name,   81); chr_facetoflag(ai_name,   81);}
    		if(rand_flag2 eq  2)
    			{chr_teleport(ai_name,   83); chr_facetoflag(ai_name,   83);}
    		if(rand_flag2 eq  3)
    			{chr_teleport(ai_name,   85); chr_facetoflag(ai_name,   85);}
    		if(rand_flag2 eq  4)
    			{chr_teleport(ai_name,   87); chr_facetoflag(ai_name,   87);}
    		if(rand_flag2 eq  5)
    			{chr_teleport(ai_name,   89); chr_facetoflag(ai_name,   89);}
    		if(rand_flag2 eq  6)
    			{chr_teleport(ai_name,   91); chr_facetoflag(ai_name,   91);}
    		if(rand_flag2 eq  7)
    			{chr_teleport(ai_name,   93); chr_facetoflag(ai_name,   93);}
    		if(rand_flag2 eq  8)
    			{chr_teleport(ai_name,   95); chr_facetoflag(ai_name,   95);}
    		if(rand_flag2 eq  9)
    			{chr_teleport(ai_name,   99); chr_facetoflag(ai_name,   99);}
    		if(rand_flag1 >  9)
    			{chr_teleport(ai_name,   100); chr_facetoflag(ai_name,   392);}
		}
	}
################ GREEN BREAKERS
	if(arena_area eq 1) {
		if(ai_team eq Konoko) {
    		if(rand_flag1 eq  0)
    			{chr_teleport(ai_name, 31); chr_facetoflag(ai_name, 31);}
    		if(rand_flag1 eq  1)
    			{chr_teleport(ai_name, 33); chr_facetoflag(ai_name, 33);}
    		if(rand_flag1 eq  2)
    			{chr_teleport(ai_name, 35); chr_facetoflag(ai_name, 35);}
    		if(rand_flag1 eq  3)
    			{chr_teleport(ai_name, 43); chr_facetoflag(ai_name, 43);}
    		if(rand_flag1 eq  4)
    			{chr_teleport(ai_name, 45); chr_facetoflag(ai_name, 45);}
    		if(rand_flag1 eq  5)
    			{chr_teleport(ai_name, 47); chr_facetoflag(ai_name, 47);}
    		if(rand_flag1 eq  6)
    			{chr_teleport(ai_name, 51); chr_facetoflag(ai_name, 51);}
    		if(rand_flag1 eq  7)
    			{chr_teleport(ai_name, 53); chr_facetoflag(ai_name, 53);}
    		if(rand_flag1 eq  8)
    			{chr_teleport(ai_name, 57); chr_facetoflag(ai_name, 57);}
    		if(rand_flag1 eq  9)
    			{chr_teleport(ai_name, 59); chr_facetoflag(ai_name, 59);}
    		if(rand_flag1 >   9)
    			{chr_teleport(ai_name, 7029); chr_facetoflag(ai_name, 7029);}
		}
		if(ai_team eq Syndicate) {
    		if(rand_flag2 eq  0)
    			{chr_teleport(ai_name, 32); chr_facetoflag(ai_name, 32);}
    		if(rand_flag2 eq  1)
    			{chr_teleport(ai_name, 34); chr_facetoflag(ai_name, 34);}
    		if(rand_flag2 eq  2)
    			{chr_teleport(ai_name, 42); chr_facetoflag(ai_name, 42);}
    		if(rand_flag2 eq  3)
    			{chr_teleport(ai_name, 44); chr_facetoflag(ai_name, 44);}
    		if(rand_flag2 eq  4)
    			{chr_teleport(ai_name, 46); chr_facetoflag(ai_name, 46);}
    		if(rand_flag2 eq  5)
    			{chr_teleport(ai_name, 50); chr_facetoflag(ai_name, 50);}
    		if(rand_flag2 eq  6)
    			{chr_teleport(ai_name, 52); chr_facetoflag(ai_name, 52);}
    		if(rand_flag2 eq  7)
    			{chr_teleport(ai_name, 56); chr_facetoflag(ai_name, 56);}
    		if(rand_flag2 eq  8)
    			{chr_teleport(ai_name, 58); chr_facetoflag(ai_name, 58);}
    		if(rand_flag2 eq  9)
    			{chr_teleport(ai_name, 60); chr_facetoflag(ai_name, 60);}
    		if(rand_flag2 eq  10)
    			{chr_teleport(ai_name, 7027); chr_facetoflag(ai_name, 7027);}
    		if(rand_flag1 >   10)
    			{chr_teleport(ai_name, 7025); chr_facetoflag(ai_name, 7025);}
		}
	}
################ DATABANK
	if(arena_area eq 2) {
		if(ai_team eq Konoko) {
    		if(rand_flag1 eq  0)
    			{chr_teleport(ai_name,   24); chr_facetoflag(ai_name,   24);}
    		if(rand_flag1 eq  1)
    			{chr_teleport(ai_name,   26); chr_facetoflag(ai_name,   26);}
    		if(rand_flag1 eq  2)
    			{chr_teleport(ai_name,   28); chr_facetoflag(ai_name,   28);}
    		if(rand_flag1 eq  3)
    			{chr_teleport(ai_name,   30); chr_facetoflag(ai_name,   30);}
    		if(rand_flag1 >   3)
    			{chr_teleport(ai_name,   7014); chr_facetoflag(ai_name, 7014);}
		}
		if(ai_team eq Syndicate) {
    		if(rand_flag2 eq  0)
    			{chr_teleport(ai_name,   25); chr_facetoflag(ai_name,   25);}
    		if(rand_flag2 eq  1)
    			{chr_teleport(ai_name,   27); chr_facetoflag(ai_name,   27);}
    		if(rand_flag2 eq  2)
    			{chr_teleport(ai_name,   29); chr_facetoflag(ai_name,   29);}
    		if(rand_flag2 eq  3)
    			{chr_teleport(ai_name,   118); chr_facetoflag(ai_name,  118);}
    		if(rand_flag2 eq  4)
    			{chr_teleport(ai_name,   7017); chr_facetoflag(ai_name, 7017);}
    		if(rand_flag2 >   4)
    			{chr_teleport(ai_name,   7018); chr_facetoflag(ai_name, 7018);}
		}
	}
################
	chr_animate(ai_name, KONCOMsuper_kick);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead eq 23) dmsg "was owned"
	if(rand_dead >  23) dmsg "is dead"
}
