########################
#  ONI TEAM ARENA 1.1  #
# AIRPORT BATTERY PACK #
########################
################ WEAPON VARIABLES (CORE)
var int arena_gun_mode= 0;
var int weapons_spawned= 0; var int can_give_weapon= 0;
var int fixed_weapon= 0; var int fixed_weapon_max;
################ MAX NUMBER OF WEAPONS (CUSTOM)
var int max_weapons= 20;
################ RESET WEAPONS (CUSTOM, CAN BE AREA-DEPENDENT)
func void ArenaResetWeapons(void) {
	weapons_spawned= 0; max_weapons= 8;
	if(arena_gun_mode > 5) max_weapons= 4;
	fixed_weapon_max= 8;
	can_give_weapon= 0;
	weapon_reset();
}
################
func void ArenaGunsNextMode(void) {
	arena_gun_mode= arena_gun_mode + 1;
	if(arena_gun_mode > 10) arena_gun_mode= 0;
}
func void ArenaGunsInfo(void) {
	if(arena_gun_mode eq  0) dmsg "No guns"	
	if(arena_gun_mode eq  1) dmsg "Mixed guns given at respawn"
	if(arena_gun_mode eq  2) dmsg "VDGs given at respawn"
	if(arena_gun_mode eq  3) dmsg "CEs given at respawn"
	if(arena_gun_mode eq  4) dmsg "PRs given at respawn"
	if(arena_gun_mode eq  5) dmsg "MBs given at respawn"
	if(arena_gun_mode eq  6) dmsg "Mixed guns lying on the ground"
	if(arena_gun_mode eq  7) dmsg "VDGs lying on the ground"
	if(arena_gun_mode eq  8) dmsg "CEs lying on the ground"
	if(arena_gun_mode eq  9) dmsg "PRs lying on the ground"
	if(arena_gun_mode eq 10) dmsg "MBs lying on the ground"
}
################ MODERATOR (CUSTOM)
func void ArenaWeaponModerator(int frags) {
	if(frags eq  10) ArenaAddWeapon();
	if(frags eq  20) ArenaAddWeapon();
	if(frags eq  30) ArenaAddWeapon();
	if(frags eq  40) ArenaAddWeapon();
	if(frags eq  50) ArenaAddWeapon();
	if(frags eq  60) ArenaAddWeapon();
	if(frags eq  70) ArenaAddWeapon();
	if(frags eq  80) ArenaAddWeapon();
	if(frags eq  90) ArenaAddWeapon();
	if(frags eq 100) ArenaAddWeapon();
	if(frags eq 110) ArenaAddWeapon();
	if(frags eq 120) ArenaAddWeapon();
	if(frags eq 130) ArenaAddWeapon();
	if(frags eq 140) ArenaAddWeapon();
	if(frags eq 150) ArenaAddWeapon();
	if(frags eq 160) ArenaAddWeapon();
	if(frags eq 170) ArenaAddWeapon();
	if(frags eq 180) ArenaAddWeapon();
	if(frags eq 190) ArenaAddWeapon();
	if(frags eq 200) ArenaAddWeapon();
}
################ ADD NEW WEAPON (CORE)
func void ArenaAddWeapon(void) {
	RandWeapon()
	if(arena_gun_mode eq 2 or arena_gun_mode eq  7) rand_weapon_name= w6_vdg
	if(arena_gun_mode eq 3 or arena_gun_mode eq  8) rand_weapon_name= w1_tap
	if(arena_gun_mode eq 4 or arena_gun_mode eq  9) rand_weapon_name= w3_phr
	if(arena_gun_mode eq 5 or arena_gun_mode eq 10) rand_weapon_name= w8_mbo
	if(arena_gun_mode > 0 and arena_gun_mode < 6) can_give_weapon= 1;
	if(arena_gun_mode > 5) fork SpawnFixedWeapon();
}
######## GIVEN WEAPON (CORE)
func void GiveRandWeapon(string ai_name) {
	if(can_give_weapon eq 1 and weapons_spawned < max_weapons) {
		can_give_weapon= 0; weapons_spawned= weapons_spawned + 1;
		chr_giveweapon(ai_name, rand_weapon_name);
	}
}
######## FIXED WEAPON (LEVEL- AND AREA-DEPENDENT) 
func void SpawnFixedWeapon(void) {
	if(rand_weapon_name eq w11_ba1) rand_weapon_name= w6_vdg
	if(weapons_spawned < max_weapons) {
		weapons_spawned= weapons_spawned + 1;
		fixed_weapon= fixed_weapon + 1;
		if(fixed_weapon > fixed_weapon_max) fixed_weapon= 0;
		if(arena_area eq 0) {
			if(fixed_weapon eq 0) weapon_spawn w1_tap 0
			if(fixed_weapon eq 1) weapon_spawn w2_sap 5
			if(fixed_weapon eq 2) weapon_spawn w3_phr 7
			if(fixed_weapon eq 3) weapon_spawn w4_psm 14
			if(fixed_weapon eq 4) weapon_spawn w5_sbg 19
			if(fixed_weapon eq 5) weapon_spawn w6_vdg 20
			if(fixed_weapon eq 6) weapon_spawn w7_scc 34
			if(fixed_weapon eq 7) weapon_spawn w8_mbo 37
			if(fixed_weapon eq 8) weapon_spawn w9_scr 40
		}
		if(arena_area eq 1) {
			if(fixed_weapon eq 0) weapon_spawn w1_tap 41
			if(fixed_weapon eq 1) weapon_spawn w2_sap 42
			if(fixed_weapon eq 2) weapon_spawn w3_phr 43
			if(fixed_weapon eq 3) weapon_spawn w4_psm 44
			if(fixed_weapon eq 4) weapon_spawn w5_sbg 45
			if(fixed_weapon eq 5) weapon_spawn w6_vdg 41
			if(fixed_weapon eq 6) weapon_spawn w7_scc 42
			if(fixed_weapon eq 7) weapon_spawn w8_mbo 43
			if(fixed_weapon eq 8) weapon_spawn w9_scr 44
		}
	}
}

